package com.muyu.marketing.domain.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.muyu.marketing.domain.req.ActivityTeamProductReq;
import com.muyu.marketing.domain.req.ActivityTeamProductUpdReq;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

import java.util.Date;

/**
 * 团购活动修改对象
 */

@Data
@SuperBuilder
@AllArgsConstructor
@NoArgsConstructor
public class ActivityTeamInfoModel {
    /**
     * 主键
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Long id;
    /**
     * 拼团名称
     */
    private String name;
    /**
     * 商品ID
     */
    private long productId;
    /**
     * 商品活动图
     */
    private String productImage;
    /**
     * 活动简介
     */
    private String introduction;
    /**
     * 单位
     */
    private String unit;
    /**
     * 轮播图
     */
    private String imageList;
    /**
     * 活动结束时间
     */
    private Date endTime;
    /**
     * 活动排序
     */
    private Long sort;
    /**
     * 活动详情
     */
    private String content;
    /**
     * 活动状态
     */
    private String status;
    /**
     * 策略类型
     */
    private String strategyType;
    /**
     * 策略ID
     */
    private Long strategyId;
    /**
     * 规格对象
     */
    private ActivityTeamProductUpdModel activityTeamProductUpdModel;

    public static ActivityTeamInfoModel activityTeamBuilder(ActivityTeamProductReq activityTeamProductReq) {
        return ActivityTeamInfoModel.builder()
                .id(activityTeamProductReq.getId())
                .name(activityTeamProductReq.getName())
                .productId(activityTeamProductReq.getProductId())
                .productImage(activityTeamProductReq.getProductImage())
                .introduction(activityTeamProductReq.getIntroduction())
                .unit(activityTeamProductReq.getUnit())
                .imageList(activityTeamProductReq.getImageList())
                .endTime(activityTeamProductReq.getEndTime())
                .sort(activityTeamProductReq.getSort())
                .content(activityTeamProductReq.getContent())
                .status(activityTeamProductReq.getStatus())
                .strategyType(activityTeamProductReq.getStrategyType())
                .strategyId(activityTeamProductReq.getProductId())
                .activityTeamProductUpdModel(ActivityTeamProductUpdModel.teamProductBuilder(activityTeamProductReq.getActivityTeamProductUpdReq()))
                .build();
    }

}
