package com.muyu.marketing.domain.model;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.muyu.marketing.domain.ActivityTeamInfo;
import com.muyu.marketing.domain.ActivityTeamProductSkuInfo;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.function.Function;

/**
 * 团购活动Id查询结果模型
 * @author
 * @date 2024-11-20 14:18:10
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class ActivityTeamInfoSkuListModel {

    /**
     * 活动Id
     */
    private Long teamId;

    /**
     * 商品Id
     */
    private Long productId;

    /**
     * 规格SKU
     */
    private String sku;

    /**
     * 拼团价格
     */
    private BigDecimal teamPrice;

    /**
     * 拼团库存
     */
    private Long teamStock;

    public static ActivityTeamProductSkuModel skuByIdModel(ActivityTeamProductSkuInfo activityTeamProductSkuInfo) {
        return ActivityTeamProductSkuModel.builder()
                .teamId(activityTeamProductSkuInfo.getTeamId())
                .productId(activityTeamProductSkuInfo.getProductId())
                .sku(activityTeamProductSkuInfo.getProductSku())
                .teamPrice(activityTeamProductSkuInfo.getTeamPrice())
                .teamStock(activityTeamProductSkuInfo.getTeamStock())
                .build();

    }
}
