package com.muyu.marketing.domain.model;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

import java.math.BigDecimal;

/**
 * 团购活动规格模型
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class ActivityTeamProductSkuModel {
    /**
     * 规格Id
     */
    private Long id;
    /**
     * 团购活动ID
     */
    private Long teamId;

    /**
     * 商品ID
     */
    private Long productId;

    /**
     * 商品SKU
     */
    private String sku;

    /**
     * 拼团价格
     */
    private BigDecimal teamPrice;

    /**
     * 拼团库存
     */
    private Long teamStock;
}
