package com.muyu.marketing.domain.model;

import com.muyu.marketing.domain.req.ActivityTeamProductUpdReq;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

import java.util.List;

/**
 * 团购活动修改对象里的集合
 */

@Data
@SuperBuilder
@AllArgsConstructor
@NoArgsConstructor
public class ActivityTeamProductUpdModel {
    /**
     * 批量修改商品规格
     */
    private List<ActivityTeamProductSkuModel> activityTeamProductSkuUpdModelList;
    /**
     * 批量删除商品规格
     */
    private List<Long> ids;
    /**
     * 批量添加商品规格
     */
    private List<ActivityTeamProductSkuAddModel> activityTeamProductSkuAddModelList;

    public static ActivityTeamProductUpdModel teamProductBuilder(ActivityTeamProductUpdReq activityTeamProductUpdReq) {
        return ActivityTeamProductUpdModel.builder()
                .activityTeamProductSkuUpdModelList(activityTeamProductUpdReq.getActivityTeamProductSkuUpdModelList())
                .ids(activityTeamProductUpdReq.getIds())
                .activityTeamProductSkuAddModelList(activityTeamProductUpdReq.getActivityTeamProductSkuAddModelList())
                .build();
    }
}
