package com.muyu.marketing.domain.resp;


import com.fasterxml.jackson.annotation.JsonFormat;
import com.muyu.marketing.domain.model.ActivityTeamInfoDatailModel;
import com.muyu.marketing.domain.model.ActivityTeamProductSkuAddModel;
import com.muyu.marketing.domain.req.ActivityTeamInfoSaveReq;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Date;
import java.util.List;

/**
 * 团购活动添加模型
 *
 * @author
 * @date 2024-11-26 09:38
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class ActivityTeamInfoDatailResp {

    /**
     * 拼团Id
     */
    private Long id;
    /**
     * 拼团名称
     */
    private String name;
    /**
     * 商品ID
     */
    private Long productId;
    /**
     * 商品活动图
     */
    private String productImage;
    /**
     * 活动简介
     */
    private String introduction;
    /**
     * 单位
     */

    private String unit;
    /**
     * 轮播图
     */

    private String imageList;
    /**
     * 活动结束时间
     */
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd")
    private Date endTime;
    /**
     * 活动排序
     */
    private Long sort;
    /**
     * 商品SkU集合
     */
    private List<ActivityTeamProductSkuResp> activityTeamProductSkuList;
    /**
     * 活动详情
     */
    private String content;
    /**
     * 活动状态
     */
    private String status;
    /**
     * 策略类型
     */
    private String strategyType;
    /**
     * 策略ID
     */
    private Long strategyId;

    public static ActivityTeamInfoDatailResp findRespBuild (ActivityTeamInfoDatailResp activityTeamInfoDatailResp){
        return ActivityTeamInfoDatailResp.builder()
                .name(activityTeamInfoDatailResp.getName())
                .productId(activityTeamInfoDatailResp.getProductId())
                .productImage(activityTeamInfoDatailResp.getProductImage())
                .introduction(activityTeamInfoDatailResp.getIntroduction())
                .unit(activityTeamInfoDatailResp.getUnit())
                .imageList(activityTeamInfoDatailResp.getImageList())
                .endTime(activityTeamInfoDatailResp.getEndTime())
                .sort(activityTeamInfoDatailResp.getSort())
                .content(activityTeamInfoDatailResp.getContent())
                .status(activityTeamInfoDatailResp.getStatus())
                .strategyType(activityTeamInfoDatailResp.getStrategyType())
                .strategyId(activityTeamInfoDatailResp.getStrategyId())
                .activityTeamProductSkuList(
                        activityTeamInfoDatailResp.getActivityTeamProductSkuList()
                                .stream()
                                .map(findResp -> ActivityTeamProductSkuResp.addReqBuild(findResp, activityTeamInfoDatailResp::getProductId))
                                .toList()
                ).build();
    }

    public static ActivityTeamInfoDatailResp datailRespBuilder(ActivityTeamInfoDatailModel datailModel,List<ActivityTeamProductSkuResp> activityTeamProductSkuResps ) {
        return ActivityTeamInfoDatailResp.builder()
                .id(datailModel.getId())
                .name(datailModel.getName())
                .productId(datailModel.getProductId())
                .productImage(datailModel.getProductImage())
                .introduction(datailModel.getIntroduction())
                .unit(datailModel.getUnit())
                .imageList(datailModel.getImageList())
                .endTime(datailModel.getEndTime())
                .sort(datailModel.getSort())
                .status(datailModel.getStatus())
                .content(datailModel.getContent())
                .strategyType(datailModel.getStrategyType())
                .strategyId(datailModel.getStrategyId())
                .activityTeamProductSkuList(activityTeamProductSkuResps)
                .build();

    }
}
