package com.muyu.marketing.domain.resp;


import com.muyu.marketing.domain.model.ActivityTeamProductSkuModel;
import com.muyu.marketing.domain.req.TeamProjectSkuInfoAddReq;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import java.util.function.Supplier;

/**
 * 团购spu库存添加模型
 *
 * @author
 * @date 2024-11-26 09:36
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class ActivityTeamProductSkuResp {

    /**
     * 规格Id
     */
    private Long id;
    /**
     * 团购活动ID
     */
    private Long teamId;

    /**
     * 商品ID
     */
    private Long productId;

    /**
     * 规格SKU
     */
    private String sku;

    /**
     * 拼团价格
     */
    private BigDecimal teamPrice;

    /**
     * 拼团库存
     */
    private Long teamStock;

    public static ActivityTeamProductSkuResp addReqBuild(ActivityTeamProductSkuResp activityTeamProductSkuResp, Supplier<Long> productId){
        return ActivityTeamProductSkuResp.builder()
                .productId(productId.get())
                .sku(activityTeamProductSkuResp.getSku())
                .teamStock(activityTeamProductSkuResp.getTeamStock())
                .teamPrice(activityTeamProductSkuResp.getTeamPrice())
                .build();
    }


    public static ActivityTeamProductSkuResp skuRespbuilder(ActivityTeamProductSkuModel activityTeamProductSkuModel) {
        return ActivityTeamProductSkuResp.builder()
                .id(activityTeamProductSkuModel.getId())
                .productId(activityTeamProductSkuModel.getProductId())
                .sku(activityTeamProductSkuModel.getSku())
                .teamStock(activityTeamProductSkuModel.getTeamStock())
                .teamStock(activityTeamProductSkuModel.getTeamStock())
                .teamPrice(activityTeamProductSkuModel.getTeamPrice())
                .build();
    }
}
